Attribute VB_Name = "APIStuff"
Option Explicit

' Used for subclassing.
Private m_OldWindowProc As Long
Private m_ClientForm As Form
Private m_TreeView As TreeView

Public Const GWL_WNDPROC = (-4)
Public Const WM_USER = &H400
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Private Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function SendMessageL Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

' TVM_GETNEXTITEM items.
Public Const TVGN_CARET = &H9
Public Const TVGN_CHILD = &H4
Public Const TVGN_DROPHILITE = &H8
Public Const TVGN_FIRSTVISIBLE = &H5
Public Const TVGN_LASTVISIBLE = &HA
Public Const TVGN_NEXT = &H1
Public Const TVGN_NEXTVISIBLE = &H6
Public Const TVGN_PARENT = &H3
Public Const TVGN_PREVIOUS = &H2
Public Const TVGN_PREVIOUSVISIBLE = &H7
Public Const TVGN_ROOT = &H0

' Mask values.
Public Const TVIF_CHILDREN = &H40
Public Const TVIF_DI_SETITEM = &H1000
Public Const TVIF_HANDLE = &H10
Public Const TVIF_IMAGE = &H2
Public Const TVIF_INTEGRAL = &H80
Public Const TVIF_PARAM = &H4
Public Const TVIF_SELECTEDIMAGE = &H20
Public Const TVIF_STATE = &H8
Public Const TVIF_TEXT = &H1

' More mask values, of the state kind.
Public Const TVIS_BOLD = &H10
Public Const TVIS_CUT = &H4
Public Const TVIS_DROPHILITED = &H8
Public Const TVIS_EXPANDED = &H20
Public Const TVIS_EXPANDEDONCE = &H40
Public Const TVIS_EXPANDPARTIAL = &H80
Public Const TVIS_OVERLAYMASK = &HF00
Public Const TVIS_SELECTED = &H2
Public Const TVIS_STATEIMAGEMASK = &HF000
Public Const TVIS_USERMASK = &HF000

' TreeView messages.
Public Const TV_FIRST = &H1100
Public Const TVM_CREATEDRAGIMAGE = (TV_FIRST + 18)
Public Const TVM_DELETEITEM = (TV_FIRST + 1)
Public Const TVM_EDITLABEL = (TV_FIRST + 14)
Public Const TVM_ENDEDITLABELNOW = (TV_FIRST + 22)
Public Const TVM_ENSUREVISIBLE = (TV_FIRST + 20)
Public Const TVM_EXPAND = (TV_FIRST + 2)
Public Const TVM_GETBKCOLOR = (TV_FIRST + 31)
Public Const TVM_GETBORDER = (TV_FIRST + 36)
Public Const TVM_GETCOUNT = (TV_FIRST + 5)
Public Const TVM_GETEDITCONTROL = (TV_FIRST + 15)
Public Const TVM_GETIMAGELIST = (TV_FIRST + 8)
Public Const TVM_GETINDENT = (TV_FIRST + 6)
Public Const TVM_GETISEARCHSTRINGA = (TV_FIRST + 23)
Public Const TVM_GETITEM = (TV_FIRST + 12)
Public Const TVM_GETITEMHEIGHT = (TV_FIRST + 28)
Public Const TVM_GETITEMRECT = (TV_FIRST + 4)
Public Const TVM_GETNEXTITEM = (TV_FIRST + 10)
Public Const TVM_GETSCROLLTIME = (TV_FIRST + 34)
Public Const TVM_GETTEXTCOLOR = (TV_FIRST + 32)
Public Const TVM_GETTOOLTIPS = (TV_FIRST + 25)
Public Const TVM_GETVISIBLECOUNT = (TV_FIRST + 16)
Public Const TVM_HITTEST = (TV_FIRST + 17)
Public Const TVM_INSERTITEM = (TV_FIRST + 0)
Public Const TVM_SELECTITEM = (TV_FIRST + 11)
Public Const TVM_SETBKCOLOR = (TV_FIRST + 29)
Public Const TVM_SETBORDER = (TV_FIRST + 35)
Public Const TVM_SETIMAGELIST = (TV_FIRST + 9)
Public Const TVM_SETINDENT = (TV_FIRST + 7)
Public Const TVM_SETINSERTMARK = (TV_FIRST + 26)
Public Const TVM_SETITEM = (TV_FIRST + 13)
Public Const TVM_SETITEMHEIGHT = (TV_FIRST + 27)
Public Const TVM_SETSCROLLTIME = (TV_FIRST + 33)
Public Const TVM_SETTEXTCOLOR = (TV_FIRST + 30)
Public Const TVM_SETTOOLTIPS = (TV_FIRST + 24)
Public Const TVM_SORTCHILDREN = (TV_FIRST + 19)
Public Const TVM_SORTCHILDRENCB = (TV_FIRST + 21)
Public Const TVM_SETLINECOLOR = (TV_FIRST + 40)
Public Const TVM_GETLINECOLOR = (TV_FIRST + 41)

' TreeView notifications.
Public Const TVN_FIRST = -400
Public Const TVN_BEGINLABELEDIT = (TVN_FIRST - 10)
Public Const TVN_BEGINDRAG = (TVN_FIRST - 7)
Public Const TVN_BEGINRDRAG = (TVN_FIRST - 8)
Public Const TVN_DELETEITEM = (TVN_FIRST - 9)
Public Const TVN_GETDISPINFO = (TVN_FIRST - 3)
Public Const TVN_GETINFOTIP = (TVN_FIRST - 13)
Public Const TVN_KEYDOWN = (TVN_FIRST - 12)
Public Const TVN_ENDLABELEDIT = (TVN_FIRST - 11)
Public Const TVN_ITEMEXPANDED = (TVN_FIRST - 6)
Public Const TVN_ITEMEXPANDING = (TVN_FIRST - 5)
Public Const TVN_SELCHANGED = (TVN_FIRST - 2)
Public Const TVN_SELCHANGING = (TVN_FIRST - 1)
Public Const TVN_SINGLEEXPAND = (TVN_FIRST - 15)

' Expanding event actions.
Private Const TVE_COLLAPSE = &H1
Private Const TVE_COLLAPSERESET = &H8000
Private Const TVE_EXPAND = &H2
Private Const TVE_EXPANDPARTIAL = &H4000
Private Const TVE_TOGGLE = &H3

Public Type POINTAPI
    X As Long
    Y As Long
End Type
Public Type NMHDR
    hwndFrom As Long
    idfrom As Long
    code As Long
End Type
Public Type NMCHAR
    hdr As NMHDR
    ch As Long
    dwItemPrev As Long
    dwItemNext As Long
End Type
Public Type TVITEM
    mask As Long
    hItem As Long
    State As Long
    stateMask As Long
    pszText As String
    cchTextMax As Long
    iImage As Long
    iSelectedImage As Long
    cChildren As Long
    lParam As Long
End Type
Public Type TVITEM_textptr
    mask As Long
    hItem As Long
    State As Long
    stateMask As Long
    pszText As Long
    cchTextMax As Long
    iImage As Long
    iSelectedImage As Long
    cChildren As Long
    lParam As Long
End Type
Public Type NMTREEVIEW_textptr
   hdr As NMHDR
   action As Long
   itemOld As TVITEM_textptr
   itemNew As TVITEM_textptr
   ptDrag As POINTAPI
End Type
' Find the node with this Tag value.
Private Function FindNodeByTag(ByVal tag_value As Long) As Node
Dim test_node As Node

    ' Examine each node.
    For Each test_node In m_TreeView.Nodes
        ' See if this is the node we want.
        If test_node.Tag = tag_value Then
            ' This is the node. Return it.
            Set FindNodeByTag = test_node
            Exit Function
        End If
    Next test_node

    ' We didn't find it.
    Set FindNodeByTag = Nothing
End Function
' Display message names.
Public Function NewWindowProc(ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Const WM_NCDESTROY = &H82
Const WM_NOTIFY = &H4E

Dim notifiy_header As NMHDR
Dim notifiy_tv_text As NMTREEVIEW_textptr
Dim h_item As Long

    ' If we're being destroyed,
    ' restore the original WindowProc.
    If msg = WM_NCDESTROY Then
        SetWindowLong _
            hWnd, GWL_WNDPROC, _
            m_OldWindowProc
    End If

    ' See if this we're expanding or collapsing.
    ' See if this is WM_NOTIFY.
    If msg = WM_NOTIFY Then
        ' Copy the WM_NOTIFY details into the
        ' notifiy_header structure.
        CopyMemory notifiy_header, ByVal lParam, LenB(notifiy_header)

        ' See if the message is coming
        ' from the target TreeView.
        If notifiy_header.hwndFrom = m_TreeView.hWnd Then
            ' This is the right TreeView.
            ' See what kind of notification this is.
            If notifiy_header.code = TVN_ITEMEXPANDING Then
                ' Examine the notify information.
                CopyMemory notifiy_tv_text, ByVal lParam, LenB(notifiy_tv_text)

                ' See what operation this is.
                If notifiy_tv_text.action = TVE_EXPAND Then
                    ' We are expanding.
                    ' Call the form's AddItems method,
                    ' passing it the expanding node.
                    h_item = notifiy_tv_text.itemNew.hItem
                    m_ClientForm.Expanding FindNodeByTag(h_item)
                End If
            ElseIf notifiy_header.code = TVN_ITEMEXPANDED Then
                ' Examine the notify information.
                CopyMemory notifiy_tv_text, ByVal lParam, LenB(notifiy_tv_text)

                ' See what operation this is.
                If notifiy_tv_text.action = TVE_COLLAPSE Then
                    ' We are collapsing.
                    ' Call the form's Collapsing method.
                    h_item = notifiy_tv_text.itemNew.hItem
                    m_ClientForm.Collapsing FindNodeByTag(h_item)

                    ' Collapse the item, removing its children.
                    SendMessageL m_TreeView.hWnd, TVM_EXPAND, _
                        TVE_COLLAPSE Or TVE_COLLAPSERESET, _
                        h_item
                End If
            End If ' End If TVN_ITEMEXPANDING or TVN_ITEMEXPANDED.
        End If ' End If message is from the target TreeView.
    End If ' End If msg = WM_NOTIFY

    ' Process the message normally. Very important!
    NewWindowProc = CallWindowProc( _
        m_OldWindowProc, hWnd, msg, wParam, _
        lParam)
End Function
' Return an array of drive names.
Public Function GetDriveNames() As String()
Dim all_drives As String
Dim len_drives As Long
Dim drive_array() As String

    ' See how long the drive buffer needs to be.
    len_drives = GetLogicalDriveStrings(0, all_drives)

    ' Allocate space for the buffer.
    all_drives = Space$(len_drives)

    ' Get the drive information.
    If GetLogicalDriveStrings(len_drives, all_drives) <> 0 Then
        drive_array = Split(all_drives, Chr$(0))

        ' Remove the last two blank entries.
        ReDim Preserve drive_array(0 To UBound(drive_array) - 2)
        GetDriveNames = drive_array
    End If
End Function

' Subclass this object.
Public Sub SubclassMe(ByVal client_form As Form, ByVal trv As TreeView)
    ' Save the form.
    Set m_ClientForm = client_form

    ' Save the TreeView's hWnd.
    Set m_TreeView = trv

    ' Subclass.
    m_OldWindowProc = SetWindowLong( _
        client_form.hWnd, GWL_WNDPROC, _
        AddressOf NewWindowProc)
End Sub
